##
## __legal_b__
##
## Copyright (c) 2015-2020 Michel Gillet
## Distributed under the wxWindows Library Licence, Version 3.1.
## (See accompanying file LICENSE_3_1.txt or
## copy at http://www.wxwidgets.org/about/licence)
##
## __legal_e__
##

from typing import List
import os

class FileConfig:
    """Class holding the information about a set of files with same source and output directory"""
    def __init__(self):
        """Constructor"""
        self.m_src_output_dir = None
        self.m_source = None
        self.m_output_file_ext = None
        self.m_tags = []
        self.m_do_tags = False
        self.m_do_swig = True
        self.m_base_inc_dir = None
        self.m_input_dir = None
        self.m_inc_base_dir = None
        self.m_pyswig = None
        self.m_script_path = None
        self.m_base_abs_path = None

    def set_script_path(self, script_path):
        """Set the path to the Python script setting up the whole work
        
        Args:
            script_path: the path to the Python script setting up the whole work.
        """
        self.m_script_path = script_path
        self.m_base_abs_path = os.path.dirname(script_path)

    def get_script_path(self):
        """Get the path to the Python script setting up the whole work
        
        Returns:
            the path to the Python script setting up the whole work.
        """
        return self.m_script_path

    def set_base_abs_path(self, base_abs_path):
        self.m_base_abs_path = base_abs_path

    def get_base_abs_path(self):
        return self.m_base_abs_path

    def set_base_inc_dir(self, base_inc_dir: str) -> None:
        """Set the folder to be used as the base of all indlude files generated by <swig_inc/>
        
        Args:
            base_inc_dir: This is set the beginning of the path for header added by <swig_inc/> annotation.
        """
        self.m_base_inc_dir = base_inc_dir

    def get_base_inc_dir(self) -> str:
        """Get the folder to be used as the base of all indlude files generated by <swig_inc/>
        
        Returns:
            This is set the beginning of the path for header added by <swig_inc/> annotation.
        """
        return self.m_base_inc_dir

    def set_pyswig(self, pyswig) -> None:
        """Set the pySwig instance"""
        self.m_pyswig = pyswig

    def get_pyswig(self):
        """Get the pySwig instance"""
        return self.m_pyswig

    def set_src_output_dir(self, src_output_dir: str) -> None:
        """Set the ouput directory where all generated files will be stored
        
        Args:
            src_output_dir: the ouput directory where all generated files will be stored
        """
        self.m_src_output_dir = src_output_dir

    def get_src_output_dir(self, local=True) -> str:
        """Get the ouput directory where all generated files will be stored
        
        Args:
            local: if True return the output path defined locally in this object, otherwise the one stored in Swig instance
        Returns:
            the ouput directory where all generated files will be stored
        """
        if local:
            return self.m_src_output_dir
        if self.m_src_output_dir is not None:
            return self.m_src_output_dir
        if self.get_pyswig() is None:
            return None
        return self.get_pyswig().get_src_output_dir()

    def set_output_file_ext(self, ext: str) -> None:
        """Set the extension that the generated files input to Swig will have
        
        Args:
            ext: the extension that the generated files input to Swig will have
        """
        self.m_output_file_ext = ext

    def get_output_file_ext(self, local=True) -> str:
        """get the extension that the generated files input to Swig will have
        
        Args:
            local: if True return the extension defined locally in this object, otherwise the one stored in Swig instance
        Returns:
            the extension that the generated files input to Swig will have
        """
        if local:
            return self.m_output_file_ext
        if self.m_output_file_ext is not None:
            return self.m_output_file_ext
        if self.get_pyswig() is None:
            return None
        return self.get_pyswig().get_output_file_ext()

    def set_source_files(self, source: List[str]) -> None:
        """Set the list of source files to process
        
        Args:
            source: the list of source files to process
        """
        self.m_source = source

    def get_source_files(self) -> List[str]:
        """Get the list of source file to process
        
        Returns:
            the list of source files to process
        """
        return self.m_source

    def set_input_dir(self, input_dir: str) -> None:
        """Set the base of the input directory, so that source files are relative to it
        
        Args:
            input_dir: the base of the input directory
        """
        self.m_input_dir = input_dir

    def add_tags(self, the_file, tags) -> None:
        """Add tags?!"""
        self.m_tags.append([the_file, tags])

    def do_tags(self, enable=True) -> None:
        """TBD"""
        self.m_do_tags = enable

    def do_swig(self, enable=True) -> None:
        """TBD"""
        self.m_do_swig = enable

    def save_tags(self, name: str) -> None:
        """TBD"""
        if not self.m_tags:
            return
        fout = open(name, "w")
        fout.write("tags=[\n")
        for tag in self.m_tags:
            fout.write("    [\"%s\",%s],\n" % (tag[0], tag[1]))
        fout.write("    ]")
        fout.close()
